/* **** BEGIN LICENSE BLOCK *****
* Version: MPL 1.1/GPL 2.0/LGPL 2.1
*
* The contents of this file are subject to the Mozilla Public License Version
* 1.1 (the "License"); you may not use this file except in compliance with
* the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is refspoof for Mozilla.
*
* The Initial Developer of the Original Code is Boyd Ebsworthy.
* Portions created by the Initial Developer are Copyright (C) 2001
* the Initial Developer. All Rights Reserved.
*
* Contributor(s):
*  Ernesto Bricca 2004/08/02 added spoof protocol / bookmark handling / ui change
* 
*
* Alternatively, the contents of this file may be used under the terms of
* either the GNU General Public License Version 2 or later (the "GPL"), or
* the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
* in which case the provisions of the GPL or the LGPL are applicable instead
* of those above. If you wish to allow use of your version of this file only
* under the terms of either the GPL or the LGPL, and not to allow others to
* use your version of this file under the terms of the MPL, indicate your
* decision by deleting the provisions above and replace them with the notice
* and other provisions required by the GPL or the LGPL. If you do not delete
* the provisions above, a recipient may use your version of this file under
* the terms of any one of the MPL, the GPL or the LGPL.
*
* ***** END LICENSE BLOCK ***** */


// init as the overlay doesnt have a onload but gets called often (every new document/window)
function refspoof_documentLoadHandler () {
    // set back to non custom as this would need to activate httpmod
    initToolbar();
    initHistSource();
    rfsp_Migrate.migrate();
}

function initToolbar() {

//history manage
    refsprefs.addPrefListener(comVar.ADD_HIST_WATCH.id, addHistoryElement);

    //starts the prefslistener for the refState button and sets its state accordingly
    // could possibly also be attached to the load handler of the button ??
    refsprefs.addPrefListener(comVar.SEND_REFERRER_STATE.id, refStateChanged);
    refsprefs.addPrefListener(comVar.SEND_REFERRER_CUSTOM.id, refStateChanged);
    refStateChanged();

};




function getCFUri(){
    var myFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    myFile.append("refspoof");
    if( !myFile.exists() || !myFile.isDirectory() ) {  
	myFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
    }
// get the file url
var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
var fileHandler = ios.getProtocolHandler("file")
                     .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
var myFileURL = fileHandler.getURLSpecFromFile(myFile);

return myFileURL;
}

function initHistSource() {

    //test if folder exists
    var myFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    myFile.append("refspoof");
    if( !myFile.exists() || !myFile.isDirectory() ) {  
	myFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
    }
    myFile.append("spoofHistory.rdf");

// get the file url
var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
var fileHandler = ios.getProtocolHandler("file")
                     .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
var myFileURL = fileHandler.getURLSpecFromFile(myFile);


    if( !myFile.exists() ) {  
	//copyOVer
	emptyDS=new RDFDataSource("chrome://refspoof/content/spoof.rdf");
	rstb.sHistDS=new RDFDataSource(myFileURL);

emptyDS.copyAllToDataSource(rstb.sHistDS);
rstb.sHistDS.save();
	//rstb.sHistDS =new RDFDataSource("file:///spoofc.rdf");
    } else {
	rstb.sHistDS =new RDFDataSource(myFileURL);
	//rstb.sHistDS =new RDFDataSource("file:///spoofc.rdf");
}

var spfHTree=document.getElementById("rstb_sHist");
spfHTree.database.AddDataSource(rstb.sHistDS.datasource);
spfHTree.builder.rebuild();

};

function rs_removeHistory() {

node = rstb.sHistDS.getNode("urn:root:links");
	    try
	    {
		for (var i = 0; i < 200; i++) {
		node.removeChildAt(1);}
	    }
	    catch(excp)
	    {
	    }
rstb.sHistDS.save();
};

function addHistoryElement(subject, topic, prefName) {
    // observe Preference

if (typeof(refsprefs)=='object'){

pipeContent=refsprefs.talktoPref(comVar.ADD_HIST_WATCH);
   rstb.newHist= pipeContent;

var isDouble=false;

var node = rstb.sHistDS.getNode("urn:root:links");
var myChildList = node.getChildren()
while (myChildList.hasMoreElements()){
var testValue = myChildList.getNext().getTarget("http://www.spoof.com/SP-rdf#spurl").getValue();
if (testValue== rstb.newHist){
isDouble=true;
}
}


if(!isDouble){

// populate rstb.oldHist order matters
rstb.oldHist3 = rstb.oldHist2;
rstb.oldHist2 = rstb.oldHist1;
rstb.oldHist1 = rstb.newHist;


//name 
elemName = rstb.uriConvert(pipeContent, "http", 0);


elemName = elemName.replace("http://www.", "");
elemName = elemName.replace("http://", "");
elemName = elemName.substr(0,20);


anNode = RDFService.GetAnonymousResource();
child = rstb.sHistDS.getNode(anNode.Value);
child=node.addChildAt(child, 1);
child.addTarget("http://www.spoof.com/SP-rdf#name", elemName);
child.addTarget("http://www.spoof.com/SP-rdf#spurl", pipeContent);
rstb.sHistDS.save();
var spfHTree=document.getElementById("rstb_sHist");
spfHTree.builder.rebuild();

}

//better this way .. else we would fill the history faster
//refsprefs.talktoPref(comVar.ADD_HIST_WATCH,"none");

}
};


function refStateChanged(subject, topic, prefName) {
if (typeof(refsprefs)=='object'){
    // observe Preference
    refState = refsprefs.talktoPref(comVar.SEND_REFERRER_STATE);
    refCustom = refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM);
    
    
    if (refState==2) {
	// static and custom will also come in here
	if (refCustom==0){
	    setGuiRefState(comVar.REF_ENABLED);
	} else if (refCustom==1){
	    
	    // on application startup disable static referrer
	    if (rcustom.obsvr!="activate"){
		rstb.refSet("enable");
		return refStateChanged();
	    }
	    setGuiRefState(comVar.REF_STATIC);
	} else if (refCustom==2){
	    setGuiRefState(comVar.REF_CUSTOM);
	} else {
	    // reset to a sane state
	    refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
	}
    } else if (refState==1) {
	setGuiRefState(comVar.REF_EMBED);
	// reset to a sane state -- no mix -- would be enforced if anyone changed via about:config
	refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
    } else if (refState==0) {
	setGuiRefState(comVar.REF_DISABLED);
	// reset to a sane state -- wouldnt matter now though against uncertainties
	refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
    }
  return 0;  
}
  return 1;  
};

function setGuiRefState(aObj) {
    
    var refStatButton = document.getElementById(comVar.SEND_REFERRER_STATE.gui);
    refStatButton.image=aObj.img;
    
    var refMenu =document.getElementById(comVar.SEND_REFERRER_STATE.guiRadio);
    refMenu.selectedIndex = aObj.radio;
};


function rstb() {
    // spoof history
 this.sHistDS = null;
 this.oldHist2 = null;
 this.oldHist1 = null;
 this.oldHist3 = null;

    // toolbar specific prefs are in utils.js .. prefsystem.js handles xul readout/init 
    
};


rstb.prototype = {
    
    /* dtor  not used why anyway
    onDestroy : function () {  },
    */
    
    
    /******************************************************************************************
    * spoof()
    * called by spoof button in overlay
    */
    spoof : function () {
	// gui change
	var spoofButton = document.getElementById(comVar.SPOOF_BUTTON_ID.gui);
	
	spoofButton.checked=true;
	
	var URI   = document.getElementById(comVar.URLBAR_ID.gui).value;
	
	this.openURI(URI, this.getReferer());
	
	// gui change
	// 0.1s button flicker .. function looses local vars
	setTimeout("document.getElementById(comVar.SPOOF_BUTTON_ID.gui).checked=false;",100); 
	
    },
	    
    
    /*****************************************************************************************
    * check the users settings for "open in tab" then calls reallyOpenURI with the
    * appropriate parameters. splitted to be able to call from the contextmenu
    */
    openURI : function (URI, refURI) {
	this.reallyOpenURI(URI, refURI, refsprefs.talktoPref(comVar.OPENTAB_ID));
    },
	    
    toggleOpenTab : function (){
	// pref change
	var enabled = refsprefs.talktoPref(comVar.OPENTAB_ID, !(refsprefs.talktoPref(comVar.OPENTAB_ID)));
	
	// gui change
	var eOpenTab = document.getElementById(comVar.OPENTAB_ID.gui);
	if (enabled) {
	    eOpenTab.setAttribute("checked", true);
	} else if (!enabled) {
	    eOpenTab.setAttribute("checked", false);
	} else {dumpme("unknown state")} 
    },
	    
    
    /*****************************************************************************************
    * reallyOpenURI() - for lack of a better name.
    * URI       = destination url
    * refURI    = referer url
    * toTab = true : open destination in a new tab. false : use current browser.
    */
    
    reallyOpenURI : function (URI , refURI, toTab){
	
	if(!URI){
	    dumpBrowserMsg("--> no url was given in the urlbar");
	    return;
	}
	
	if(!refURI) {
	    dumpBrowserMsg("--> no referrer was given in the refbar");
	    return;
	    
	}
	
	/* clean up the ! */
	URI         = this.cleanURI(URI);
	refURI      = this.cleanURI(refURI);
	
	//create spoof uri
	
	var spoofURI = this.uriConvert(URI, "spoof")+";"+ this.uriConvert(refURI, "ref");

 this.openSpoofUri(spoofURI, toTab);

    },

    openSpoofUri : function (spoofURI, toTab){
	

	var browser = getBrowser();
	
	if(toTab) {
	    var tab = browser.addTab(spoofURI);
	    
	    if (!refsprefs.talktoPref(comVar.BROWSER_LOAD_TABS_IN_BG_ID))
		    browser.selectedTab = tab;
	} else {
	    browser.loadURI(spoofURI);
	}

    },
	    
    
    
    /*****************************************************************************************
    * referer handling
    **/
    
    getReferer : function () {
	var refisurl = refsprefs.talktoPref(comVar.URLISREF_ID);
	if(refisurl){
	    return document.getElementById(comVar.URLBAR_ID.gui).value;
	} else {
	    refbarValue=document.getElementById(comVar.REFBAR_ID.gui).value;
	    this.addRefbarMenuItem(refbarValue);
	    return refbarValue;
	}
    },
	    
    toggleUrlref : function(enable){
	
	
	// pref change
	if (enable==null){
	    var enabled = refsprefs.talktoPref(comVar.URLISREF_ID, !(refsprefs.talktoPref(comVar.URLISREF_ID)));
	    enable = !enabled
		}
	
	// gui change
	var eRefurl = document.getElementById(comVar.URLISREF_ID.gui);
	var eRefbar = document.getElementById(comVar.REFBAR_ID.gui);
	
	if (!enable) {
	    eRefbar.value = "";  // clean refbar
	    eRefurl.checked = true;
	    eRefbar.setAttribute("disabled", "true");
	    dumpNagBrowserMsg("click the 'spoof button' - to spoof (load) the actual page with urlbar url as referrer");
	    
	} else if (enable) {
	    eRefurl.checked = false;
	    eRefbar.removeAttribute("disabled");
	} else {dumpme("unknown state");}
    },
	    
    
    
    addRefbarMenuItem : function(term){
	
	if(term=="") {
	    dumpBrowserMsg("--> no referrer was given in the refbar -- it would be just behave like a normal bookmark :/");
	    return;
	}
	var myRefbarMenuList = document.getElementById(comVar.REFBAR_ID.gui);
	
	var myRefbarPopup = myRefbarMenuList.firstChild;
	
	
	var intMaxHistory = refsprefs.talktoPref(comVar.REFBAR_ID);
	
	var alreadyInHistory = false;
	
	var intNrHistoryItems = myRefbarPopup.childNodes.length; 
	
	
	
	for (var i = 0; i < intNrHistoryItems; i++) {
	    
	    if (term == myRefbarPopup.childNodes[i].getAttribute("label")) {
		
		alreadyInHistory = true;
		
	    }
	    
	}
	
	
	
	if(!alreadyInHistory) {
	    
	    // Add search term to history list 
	    
	    var newMenuItem = document.createElement("menuitem");
	    
	    newMenuItem.setAttribute("label", term);
	    
	    myRefbarPopup.insertBefore(newMenuItem, myRefbarPopup.childNodes[0]);
	    
	    
	    
	    // Check the length of dropdown list an cut if ness
	    
	    if (myRefbarMenuList.firstChild.childNodes.length >= intMaxHistory){
		
		myRefbarMenuList.removeItemAt(intMaxHistory);
	    }
	    
	}
	
	
	
    },
	    
    
    cleanHist : function (){
	var myRefbarMenuList = document.getElementById(comVar.REFBAR_ID.gui);
	
	
	
	var i = 0;
	
	var len = 0;
	
	
	
	len = myRefbarMenuList.firstChild.childNodes.length;
	
	for(i = len - 1; i > -1; i--) {
	    
	    myRefbarMenuList.removeItemAt(i); 
	    
	}
    },
	    
    dumpRef : function (){  // to the refbar
	
	if (refsprefs.talktoPref(comVar.URLISREF_ID)) {
	    this.toggleUrlref();
	}
	myRef=getBrowser().contentDocument.referrer;
	document.getElementById(comVar.REFBAR_ID.gui).value=myRef;
    },
	    
    splitSpoofUri : function (){  // to the refbar
	myURI=document.getElementById(comVar.URLBAR_ID.gui).value;
	
	
	//test if it's a spoof url
	if (myURI.substr(0,6) == "spoof:") {
	    if (refsprefs.talktoPref(comVar.URLISREF_ID)) {
		this.toggleUrlref();
	    }
	    
	    document.getElementById(comVar.URLBAR_ID.gui).value = this.uriConvert(myURI, "http", 0);
	    document.getElementById(comVar.REFBAR_ID.gui).value = this.uriConvert(myURI, "http", 1);          
	    
	} else {
	    // tell that it's not a spoof url
	    dumpBrowserMsg("the urlbar doesn't contain a spoof: uri -- so the split is not possible");
	    
	}
	
    },
	    
    /*****************************************************************************************
    * set refererState 
    **/  
    refSet : function (toState){

	switch (toState){
	  case 'enable':
	    
	    refsprefs.talktoPref(comVar.SEND_REFERRER_STATE, 2);
	    refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
	    break;
	  case 'embed':
	    refsprefs.talktoPref(comVar.SEND_REFERRER_STATE, 1);
	    refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
	    break;
	  case 'disable':
	    refsprefs.talktoPref(comVar.SEND_REFERRER_STATE, 0);
	    refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 0);
	    break;
	  case 'static':
	    // variable to check if the refspoof is active (startup check)
	    rcustom.obsvr = "activate";
	    
	    // message use same window invoke
	    dumpNagBrowserMsg("the refbar is used as input -- use tabbed browsing as the query is attached to the currently used window (refbar) !!");
	    
	    refsprefs.talktoPref(comVar.SEND_REFERRER_STATE, 2);
	    refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 1);
	    
	    rcustom.startModify();
	    
	    
	    break;
	  case 'custom':
	    refsprefs.talktoPref(comVar.SEND_REFERRER_STATE, 2);
	    //refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, 2);
	}
	
    },
	    
    
    /*****************************************************************************************
    * sidebar
    **/
    
    // gets called in the xul 
    
    /*****************************************************************************************
    * bookmark functions
    **/
    
    bookmark : function(){
	// gui change
	var bookmButton = document.getElementById(comVar.BM_BUTTON_ID.gui);
	bookmButton.checked=true;
	
	// storeMethod:
	// 0==read out the refbar and the urlbar
	// 1==use the properties of the topfront page
	// todo -- behaviour shall be able to be reversed via alt
	var myUri="";var myRef="";
	
	// keypressed shift modulo % -- storeMethod = (storeMethod + 1) % 2 
	//-- counterpart in the xul from utils.js
	var storeMethod = refsprefs.talktoPref(comVar.STORE_METHOD_ID);
	var shiftPressed = refsprefs.talktoPref(comVar.SHIFT_PRESSED_ID);
	if (shiftPressed == 1){storeMethod = (storeMethod + 1) % 2}
	
	
	switch (storeMethod){
	  case 0:
	    myUri=document.getElementById(comVar.URLBAR_ID.gui).value;
	    myRef=this.getReferer();
	    break;
	  case 1:
	    myUri=getBrowser().contentDocument.location;
	    myRef=getBrowser().contentDocument.referrer;
	}
	
	if(myUri=="" || myRef=="") {  // pbly later store as simple url if myRef=="" but error msg is better
	    dumpNagBrowserMsg("no url or referrer was given");
	} else {
	    
	    myUri  = this.cleanURI(myUri);
	    myRef  = this.cleanURI(myRef);
	    
	    myUri = this.uriConvert(myUri, "http");
	    myRef = this.uriConvert(myRef, "http");
	    
	    this.storeSpoof(myUri, myRef);
	}
	
	// gui change
	// .1 s button flicker .. function looses local vars
	setTimeout("document.getElementById(comVar.BM_BUTTON_ID.gui).checked=false;",100); 
	
    },
	    
    pipeinBkmrk : function(){
	//listens to the BKMRK_PIPE_ID
	// write description , rating?? to a pref   
	//xpPref.setStringPref("network.http.sendRefererHeader", "tst");
	
	//var myURI = aURI.spec;
	// write url to a pref that is being watched   
	//xpPref.setCharPref("network.http.sendRefererHeader", myURI);
	
	// creation of bookmark is enforced
	
    },
	    
    storeSpoof : function(myUri, myRef){
	// convert to spoofuri
	
	myUri = myUri.replace("http://", "spoof://");
	var bmName = myUri;
	myRef = myRef.replace("http://", "ref://");
	var spoofUri = myUri +";"+ myRef;
	this.storeBkmrk(spoofUri, bmName);
    },
	    
    storeBkmrk : function(spoofUri, bmName){
	// analog from above    
	// storeLocation:
	// 0==show save dialog
	// 1==use the selected folder as direct save
	// -- behaviour shall be able to be reversed via alt
	
	//-- counterpart in the xul from utils.js
	var storeLocation = refsprefs.talktoPref(comVar.STORE_LOCATION_ID);
	var altPressed = refsprefs.talktoPref(comVar.ALT_PRESSED_ID);
	if (altPressed == 1){storeLocation = (storeLocation + 1) % 2}
	

	rs_createBookmark(spoofUri, bmName, storeLocation); 
	//in utils.js 

	    // be sure -- on alt click ?? doesnt jump back in the main function
	    setTimeout("document.getElementById(comVar.BM_BUTTON_ID.gui).checked=false;",2000); 

	
    },
	

    handleSHistList : function (menuItem) {
		var spoofUri = menuItem.getAttribute("theUrl");

 this.openSpoofUri(spoofUri, refsprefs.talktoPref(comVar.OPENTAB_ID));

    },
	 
    
    
    /*****************************************************************************************
    * aid
    **/
    
    /* removes '!' from URLs */
    
    cleanURI : function (URI) {
	//strip the bang
	URI = URI.toString();
	URI = URI.replace(/!/g, "");
	return URI;
    },
	    
    
    uriConvert : function (URI, scheme, part) {
	
		if (URI.substr(0,5) == "hxxp:") {
		URI = "http:" + URI.substr(5);
	    }
	
	
	if (URI.substr(0,6) == "spoof:") {
	    // if its a spoof uri cut away the ref and reformat
	    var partURI = URI.split(";ref:");
	    if (part==null || partURI[1]==null){
		part=0;
	    }
	    URI = partURI[part];
	    
	    // "spoof:"
	    if (part==0){
		URI = "http:" + URI.substr(6);
	    }
	    
	    // "ref:"
	    if (part==1){
		URI = "http:" + URI;
	    }
	    
	}
	
	// could be refined a bit to represent the other standard notations http:, http:/, http://
	// even the component could be refined
	if (URI.substr(0,5) != "http:") {
	    URI = "http://" + URI;
	}
	return scheme + URI.substr(4);
    },
	    
    uriMakeValid : function (URI) {
	
	myURI = URI;
	
	if (URI.substr(0,6) == "spoof:") {
	    myURI = this.uriConvert(URI, "http", 0);
	} else if (URI.substr(0,4) == "ftp:") {
	}else if (URI.substr(0,5) == "http:") {            
	} else {
	    myURI = "http://" + URI;
	}
	
	return myURI;
    },
	    
    /*****************************************************************************************
    * prefsystem
    **/
    
    prefWindow: function () {
	
	window.openDialog(
		
	'chrome://refspoof/content/options.xul',
		
	'',
		
	'centerscreen,chrome,dialog,resizable,dependent'
	
	);
	
    },
	    
    convWindow: function () {
	
	window.openDialog(
		
	'chrome://refspoof/content/convert.xul',
		
	'',
		
	'centerscreen,chrome,dialog,resizable,dependent'
	
	);
    },
	    
    
    /*****************************************************************************************
    * context menu handler function
    * gContextMenu info in : contentAreaContextOverlay.xul and nsContextMenu.js
    * see contentAreaUtils.js for usefull stuff.
    **/
    
    
    contextMenuListener : function() {
	if(gContextMenu) {
	    gContextMenu.showItem( "context-spoof", gContextMenu.isTextSelected || gContextMenu.onLink);
	    gContextMenu.showItem( "context-spoof-sep", gContextMenu.isTextSelected || gContextMenu.onLink);
	}
    },
	    
    // get data under the cursor, selected text then link.
    getContextData : function () {
	var data = '';
	if(gContextMenu.isTextSelected) {
	    data = gContextMenu.searchSelected();
	} else if(gContextMenu.onLink) {
	    data = gContextMenu.getLinkURL();
	} else { alert('nothing useful here :)'); }
	
	return data;
    },
	    
    // open as ref = url the context menu target //openContextDataAsURI
    openContextDataAsURI : function() {
	var URI = this.getContextData();
	if(URI != '') {
	    // copied from toggleUrlref hack!
	    var enabled = refsprefs.talktoPref(comVar.URLISREF_ID, !(refsprefs.talktoPref(comVar.URLISREF_ID)));
	    if (enabled) {this.toggleUrlref();}
	    this.openURI(URI, URI);
	}
    },
	    
    // set the urlbar to context menu target
    setContextDataToURLBar : function () {
	var URI = this.getContextData();
	if(URI != '') {
	    document.getElementById(comVar.URLBAR_ID.gui).value = URI;
	}
    },
	    
    // set the referer bar to context menu target
    setContextDataToRefererBar : function () {
	var URI = this.getContextData();
	if(URI != '') {
	    // copied from toggleUrlref hack!
	    var enabled = refsprefs.talktoPref(comVar.URLISREF_ID, !(refsprefs.talktoPref(comVar.URLISREF_ID)));
	    if (!enabled) {this.toggleUrlref();}
	    document.getElementById(comVar.REFBAR_ID.gui).value = URI;
	}
    }
    
    
};



/*****************************************************************************************
* dragNdrop
**/


function myretrieveURLFromData (aData, flavour) {
    
    switch (flavour) {
	//XXX : for some reason when plain text is dragged from
	//the content area, the flavour is set a text/x-moz-url
	//i don't know how to differentiate an url from a text drag.
      case "text/unicode":
      case "text/x-moz-url":
	var data = aData.toString();
	//remove leading useless char
	data = data.replace(/^(n|r|t|s)+/g, "");
	//remove trailing useless char
	data = data.replace(/(n|r|t|s)+$/g, "");
	//extract url from possible valid x-moz-uri
	var separator = data.indexOf("n");
	if (separator != -1)
		data = data.substr(0, separator);
	
	return data;
	
      case "application/x-moz-file":
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	return ioService.getURLSpecFromFile(aData);
    }
    return null;
}



/***** DnD test *****/
var btDragObserver = {
    
    onDrop: function (aEvent, aXferData, aDragSession) {
	var url = myretrieveURLFromData(aXferData.data, aXferData.flavour.contentType);
	if(url) {
	    rstb.toggleUrlref(true);
	    rstb.openURI(url, url);
	}
    },
	    
    onDragOver: function (aEvent, aFlavour, aDragSession) {
	// shows the curser uparrow but doesnt allow other interface change like statusbar switch :/
	aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;
	
    },
	    
    
    getSupportedFlavours: function () {
	var flavourSet = new FlavourSet();
	
	flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
	flavourSet.appendFlavour("text/x-moz-url");
	flavourSet.appendFlavour("text/unicode");
	
	return flavourSet;
    }
    
}



/*****************************************************************************************
* http observe for static referrer
**/

var rcustom = {
    
    startModify : function ()   {
	
	this.observe(null,"httpmod-activate",null);
	
    },
	    
    killModify : function ()
    {
	var obsService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	obsService.removeObserver(this, "http-on-modify-request", false);
	this.obsvr = "";
    },
	    
    addObserver : function (observer)
    {
	this.observers[observer] = observer;
    },
	    
    removeObserver : function (observer)
    {
	delete this.observers[observer];
    },
	    
    observe: function(aSubject, aTopic, aData) {
	if (aTopic == 'http-on-modify-request') {
	    aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
	    this.onModifyRequest(aSubject);
	    
	} else if (aTopic == 'httpmod-activate') {
	    
	    // used to reattach the observer to the current window -- refbar
	    try
	    {
		this.killModify();
	    }
	    catch(excp)
	    {
	    }
	    
	    
	    var obsService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	    obsService.addObserver(this, "http-on-modify-request", false);                
	    // Initialisation of all needed vars .. dont know how it works in detail yet seems to influence timing/response though
	    this.observers = new Array();
	    this.delays    = new Array();
	    
	} else {
	    dumpme("nsHeaderInfo: unknown TOPIC: " + aTopic + "n");
	}
    },
	    
    onModifyRequest : function (oHttp)
    {
	
	refStateCtrl = refsprefs.talktoPref(comVar.SEND_REFERRER_CUSTOM, null, 0);
	
	if (refStateCtrl==0){
	    this.killModify();
	    return;
	}
	
	oHttp.QueryInterface(Components.interfaces.nsIHttpChannel);
	ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	
	refCustomUri = document.getElementById(comVar.REFBAR_ID.gui).value;
	if (refCustomUri == ""){
	    // not sure if this works test !!!!
	    if (refsprefs.talktoPref(comVar.URLISREF_ID)) {
		dumpNagBrowserMsg("url=ref is set -- so i'll take the actual url as referrer");
		refCustomUri = document.getElementById(comVar.URLBAR_ID.gui).value;
	    } else {
		//disable referrer and tell about
		dumpBrowserMsg("no referrer was given in the refbar -- same as sending no referrer -- so i set it to 'disable referrer'");
		rstb.refSet("disable");
	    }
	}
	
	//refCustomUri has to start with http: or ftp: we enforce http if nothing is given
	refCustomUri=rstb.uriMakeValid(refCustomUri);
	dumpme(refCustomUri);
	
	refnsiURI  = ios.newURI(refCustomUri, null, null);
	
	oHttp.referrer=refnsiURI;
	
	//dumpme(oHttp.referrer.spec);
	
	
	
    }
    
}